<template>
  <v-container>
    <v-row justify="space-between">
      <v-col cols="12" md="6">
        <p class="page-title">
          Información del Supervisor cliente
        </p>
      </v-col>
    </v-row>
    <v-card outlined class="mx-auto" max-width="100%">
      <!---<confirmation-modal :is-open="openModal" :modal-text="modalText" @confirm="confirmRegister" @cancel="cancelRegister" />--->
      <v-card-subtitle class="pb-0">
        <image-field v-model="supervisor.user.image" :disabled="disabled_user_info" :validation="imageValidation"  :url-image="supervisor.profileImage"/>
        <v-divider></v-divider>
        <v-form ref="form" lazy-validation>
          <v-container fluid>
            <select-field  v-model="typeDocumentSelected" :disabled="disabled_user_info" :items="typesDocument" fieldName="Tipo de documento" ></select-field>
            <register-field-validation v-if="typeDocumentSelected==='DNI'" v-model="supervisor.user.document" :disabled="disabled_user_info" field-name="DNI" :validation="DNIValidation" />
            <register-field-validation v-if="typeDocumentSelected==='CARNET EXTRANJERÍA'" v-model="supervisor.user.document" :disabled="disabled_user_info" field-name="Carnet de extranjería" :validation="carnetValidation"  />
            <register-field-validation v-if="typeDocumentSelected==='PASAPORTE'" v-model="supervisor.user.document" :disabled="disabled_user_info" field-name="Pasaporte"  :validation="passportValidation"  />

            <register-field-validation v-model="supervisor.user.name" :disabled="disabled_user_info || typeDocumentSelected=='DNI'" field-name="nombre" :validation="nameValidation" />
            <register-field-validation v-model="supervisor.user.fatherLastname" :disabled="disabled_user_info || typeDocumentSelected=='DNI'" field-name="Apellido Paterno" :validation="fatherLastnameValidation" />
            <register-field-validation v-model="supervisor.user.motherLastname" :disabled="disabled_user_info || typeDocumentSelected=='DNI'" field-name="Apellido Materno " :validation="motherLastNameValidation" />
            <register-field-validation v-model="supervisor.email" :disabled="disabled_user_info" field-name="Correo" :validation="emailValidation"   />
            <register-field-validation v-model="supervisor.phoneNumber" :disabled="disabled_user_info" field-name="Celular" :validation="phoneValidation" :obligatory="false" />
          </v-container>
        </v-form>
      </v-card-subtitle>
      <v-card-actions class="d-flex justify-end">
        <v-btn depressed color="primary" style="padding: 15px" rounded outlined @click="editar">EDITAR</v-btn>
      </v-card-actions>
      <br>
    </v-card>
  </v-container>
</template>

<script>
import {mapActions, mapGetters, mapState} from "vuex";
import RegisterFieldValidation from "~/components/InputField/RegisterFieldValidation";
import ButtonsRegisterForm from "~/components/InputField/ButtonsRegisterForm.vue";
import imageField from "~/components/InputField/ImageField";
import ConfirmationModal from '~/components/register/confirmationModal';
import { DNIRules, nameRules, fatherLastnameRules, motherLastnameRules, emailRules, imageFileRules, phoneRules, carnetRules, passportRules } from "@/helpers/validation";
import SelectField from "~/components/InputField/SelectField.vue"

export default {
  name: "ShowClientSupervisor",
  components: { RegisterFieldValidation, ButtonsRegisterForm,imageField, ConfirmationModal,SelectField},
  data: () => ({
    typeDocumentSelected: 'DNI',
    typesDocument: ['CARNET EXTRANJERÍA', 'DNI', 'PASAPORTE'],
    disabled_user_info: true,
    isValidForm: false,
    DNIValidation: DNIRules,
    carnetValidation: carnetRules,
    passportValidation: passportRules,
    nameValidation: nameRules,
    fatherLastnameValidation: fatherLastnameRules,
    motherLastNameValidation: motherLastnameRules,
    emailValidation: emailRules,
    imageValidation: imageFileRules,
    phoneValidation: phoneRules,
    openModal: false,
    modalText: '¿Estás seguro que deseas registrar a este supervisor cliente?',
    snackBar:{
      show:false,
      color:'',
      text:'',
    },
    supervisor: {
      user:{
        image: null,
      },
    }
  }),

  computed:{
    ...mapState({
      checkedClientSupervisor: state => state.client-supervisor.checkedClientSupervisor,
    }),
    ...mapGetters({
      storedClientSupervisor: 'client-supervisor/getOneClientSupervisor',
    }),
  },
  async mounted() {
    await this.getAClientSupervisor();
  },
  methods:{
    ...mapActions({
      getClientSupervisor: 'client-supervisor/getAClientSupervisor',
      saveClientSupervisor: 'client-supervisor/saveClientSupervisor',
      checkedInformationClientSupervisor: 'client-supervisor/checkedInformationClientSupervisor'
    }),
    async getAClientSupervisor() {
      await this.getClientSupervisor({ uuid: this.$route.params.id });
      this.supervisor = Object.assign({}, this.storedClientSupervisor);
      console.log("print supervisor");
      console.log(this.supervisor);
      if (this.supervisor.user.typeDocument === 'CARNET') {
        this.supervisor.user.typeDocument = 'CARNET EXTRANJERÍA';
      }
    },
    editar(){
      this.$router.push(`/supervisores-clientes/editar-supervisor-cliente/${this.supervisor.uuid}`);
    },
  }
}
</script>

<style scoped>
.page-title {
  font-family: 'Montserrat', sans-serif;
  font-size: 1.5rem;
  margin-top: 1rem;
  margin-left: 1rem;
}
.buttonRegisterLeft {
  margin-top: 1rem;
}
.buttonRegisterRight {
  margin-top: 1rem;
}
</style>
